/* class Client  V 0.5
 *
 * IT= Intervalle de Temps
 * Client= Objet definissant l'entite d'un client et qui determine :
 * - Sa categorie/type de client; prix A, prix B, entreprise...
 * - Sa Priorite ?
 * - Son budget
 * - Duree de communication (entier: nbr d'IT)
 * - Compteur d'attente (entier: nbr d'IT)
 * - Largeur de bande passante utilisee par paquets. (bandwidthuse)
 *
 */

class Client {

    // Variables
    private int type=0;
           /* type=0      -->     pauvre (ou normal)
	    * type=1      -->     riche
	    */
    private int callduration=0;
    private int waitcounter=0;
    private double budget=0.;
    private int bandwidthuse=0;
    private int priority=0;
    public int heure_darrive;
    private boolean elasticite;
    
/**  CONSTRUCTEURS */
public Client(int type, int callduration, double budget, int bandwidthuse) {
    this.type=type;
    this.callduration=callduration;
    this.budget=budget;
    this.bandwidthuse=bandwidthuse;
}

public Client(int callduration, double budget) {
    this.type=0;
    this.callduration=callduration;
    this.budget=budget;
}

public Client(int callduration, double budget, int bandwidthuse) {
    this.type=0;
    this.callduration=callduration;
    this.budget=budget;
    this.bandwidthuse=bandwidthuse;
}

public Client(int type, int callduration, double budget, int bandwidthuse,int heure_darrive, boolean elasticite) {
	this.type=type;
    this.callduration=callduration;
    this.budget=budget;
    this.bandwidthuse=bandwidthuse;
    this.heure_darrive = heure_darrive;
    this.elasticite = elasticite;
}

public Client(int type, int callduration, double budget, int bandwidthuse, boolean elasticite) {
	this.type=type;
    this.callduration=callduration;
    this.budget=budget;
    this.bandwidthuse=bandwidthuse;
    this.elasticite = elasticite;
}

public Client() { }


//--------------------//

/** Fait attendre le client une IT de plus */
public void waiting() {
    waitcounter++;
}

/** reduit le temps de communication du Client */
public void reduceCallDuration(int nb_interval) {
    callduration -= nb_interval;
}

public void reduceCallDuration(int nb_interval, double price) {
    callduration -= nb_interval;
    pay(price);
}

/** Fait payer le client ce kil a depensee pendant une IT */
public boolean pay(double depenses) {
    budget -= depenses;
    if(budget < 0)
    {
	//budget += depenses;
	// Cela voudrait dire qu'on arrete la connection du client
	// sans lui faire payer ce qu'il ne peut pas payer en entier.
	// MAIS CELA PEUT DEPENDRE DU TYPE DE PRICING QU'ON LUI INFLIGE
	// d'ou l'utilite de la methode suivante.
	return false; 
    }
    else return true;
}

/** Peut servir a rendre de l'argent au client ou a remplir son budget */
public void gain(double credit) {
    budget += credit;
}


//----- METHODES d' INITIALISATION de valeurs privates -----//

public void setPriority(int p) { priority=p; }

public void setBudget (double b) {budget=b;}

public void setBWU (int bu) {bandwidthuse=bu;}

public void setCallDuration (int cd) {callduration=cd;}

//----- METHODES de RETOUR de valeurs privates -----//

/** Retourne la bande passante utilisee par le client **/
public int getBandwidth() { return bandwidthuse; }
public int getBWU() { return bandwidthuse; }

/** Retourne le bbudget du client **/
public double getBudget() { return budget; }

public int getType() { return type ;}

public int getPriority() { return priority; }

public int getCallDuration() { return callduration; }

public int getWaitCounter() { return waitcounter; }
//--- End Of Class
} 
